/*
 * file:        Base.h
 * purpose:     common definitions
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#ifndef BASE_H
#define BASE_H
#include <stdint.h>

namespace srd {

#ifdef EXTERN
#  undef EXTERN
#endif
#ifdef PLACE_GLOBALS_HERE
#  define EXTERN
#else
#  define EXTERN extern
#endif

#define STRx(s)  #s
#define STR(s)   STRx(s)

#define IO_CHECK            10                             // milliseconds to wait for next check
#define BUTTON_SAMPLING     12                             // number of times a button must be pressed

/*
 * enable one of the three
 */
//#define ENCODER_1_STEP
#define ENCODER_2_STEPS
//#define ENCODER_4_STEPS

#define LCD_COLS            27
#define LCD_LINES           4
#define LCD_WANT_SAMPLE

};

#pragma GCC diagnostic ignored "-Wwrite-strings"
#pragma GCC diagnostic ignored "-Wunused-parameter"

EXTERN void operator delete(void *unused);

#endif
