/*
 * file:        Encoder.C
 * purpose:     class definition for turning encoders (works together with system tick interrupt)
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include "Encoder.h"

using namespace srd;

CounterHandler::~CounterHandler() {
  }

void CounterHandler::handleCounter(int8_t delta) {
  }


DefaultCounterHandler::~DefaultCounterHandler() {
  }


void DefaultCounterHandler::handleCounter(int8_t delta) {
  counter += delta;
  }


Encoder::~Encoder() {
  }


void Encoder::run() {
  int8_t i=0, delta=0;

  // check encoder turns
  if (right.isHigh()) i  = 1;
  if (left.isHigh())  i ^= 3;
  delta = encLast - i;

  if (delta & 1) {
     encLast = i;
     encDelta += (delta & 2) - 1;
     }
#if   defined(ENCODER_1_STEP)
  handler->handleCounter(enc_delta);
  enc_delta = 0;
#elif defined(ENCODER_2_STEPS)
  i = encDelta;
  encDelta = i & 1;
  handler->handleCounter(i >> 1);
#elif defined(ENCODER_4_STEPS)
  i = encDelta;
  encDelta = i & 3;
  handler->handleCounter(i >> 2);
#endif
  }


void Encoder::setCounterHandler(CounterHandler* handler) {
  this->handler = handler;
  }
