/*
 * file:        PushButton.C
 * purpose:     class for usage of pushbuttons with debouncing by interrupt
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2004-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include "PushButton.h"

using namespace srd;

void PushButton::checkPressed() {
  if (activeHigh) {
     if (pin.isHigh()) ++buttonPressed;
     else                buttonPressed = 0;
     }
  else {
     if (pin.isLow()) ++buttonPressed;
     else               buttonPressed = 0;
     }
  }
